﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;

namespace _97572
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            for (int i = 0; i < 5; i++)
            {
                dt.Columns.Add(string.Format("Col{0}", i), typeof(string));

            }
            ultraGrid1.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(ultraGrid1_InitializeLayout);
            ultraGrid1.BeforeRowDeactivate += new CancelEventHandler(ultraGrid1_BeforeRowDeactivate);
            ultraGrid1.DataSource = dt;
            
            foreach (GridKeyActionMapping key in ultraGrid1.KeyActionMappings)
            {
                if (key.KeyCode == Keys.Enter && key.ActionCode == UltraGridAction.CommitRow && key.StateRequired == (UltraGridState.AddRow| UltraGridState.RowDirty))
                {
                    key.StateRequired = UltraGridState.RowDirty;
                    key.StateDisallowed = UltraGridState.AddRow;
                    Debug.WriteLine(key.ActionCode);
                }
            }
        }

        void ultraGrid1_BeforeRowDeactivate(object sender, CancelEventArgs e)
        {
            if (ultraGrid1.ActiveRow.IsAddRow)
            {
                foreach (UltraGridCell item in ultraGrid1.ActiveRow.Cells)
                {
                    if (item.Value.ToString().Trim().Length <= 0 && !item.Column.Hidden)
                    {
                        MessageBox.Show("Please select a value for " + item.Column.Header.Caption.ToString());
                        e.Cancel = true;
                        ultraGrid1.ActiveCell = item;
                        ultraGrid1.PerformAction(UltraGridAction.EnterEditMode);
                        break;
                    }

                }
            }
        }

        void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowAddNew = Infragistics.Win.UltraWinGrid.AllowAddNew.TemplateOnBottom;
        }
    }
}
